package com.inca.npbusi.sales.bms_sa_doc;

import com.inca.np.anyprint.Printplan;
import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.RecordTrunk;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.DefaultNPParam;
import com.inca.np.util.SendHelper;
import com.inca.npbusi.saHelper.CheckHelper;
import com.inca.npbusi.sales.bms_sa_doc.Bms_sales_app_rejected_hov.Bms_chose_order_hov;
import com.inca.npbusi.sales.bms_sa_doc.Bms_sales_app_rejected_hov.Bms_chose_xd_order_hov;
import com.inca.npbusi.sales.bms_sa_doc.Bms_sales_app_rejected_hov.Bms_sales_app_rejected_hov;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.npx.ste.Apinfo;
import com.inca.pubsrv.ApproveDialog;
import com.inca.pubsrv.Entrychose;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.NptrDBHelper;
import com.inca.pubsrv.ObjectUtils;
import com.inca.pubsrv.hov.bms_tr_pos_hov.Bms_tr_pos_hov;
import com.inca.zx.dialog.ListSetDialog;
import java.awt.Component;
import java.awt.Frame;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Vector;
import javax.swing.JOptionPane;
import org.apache.log4j.Category;

public class Bms_sales_mde extends CMdeModelAp implements ActionListener {
   private static Category logger = Category.getInstance(Bms_sales_mde.class);
   ApproveDialog dialog;
   String entryid = "";
   String entryname = "";
   protected String nosapriceinfo = "";

   public String getEntryid() {
      return this.entryid;
   }

   public void setEntryid(String entryid) {
      this.entryid = entryid;
   }

   public String getEntryname() {
      return this.entryname;
   }

   public void setEntryname(String entryname) {
      this.entryname = entryname;
   }

   public Bms_sales_mde(CFrame frame, String title) {
      super(frame, title);
      if (!DefaultNPParam.runonserver || DefaultNPParam.debug != 0) {
         this.setResetbeforenew(true);
         this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
         this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
         this.nosapriceinfo = NpbusiDBHelper.getSysParaConfig(this.entryid, "nosapriceinfo");
      }

   }

   protected CMasterModel createMastermodel() {
      return new Bms_sales_master(this.frame, this);
   }

   protected CDetailModel createDetailmodel() {
      return new Bms_sales_detail(this.frame, this);
   }

   public String getMasterRelatecolname() {
      return "salesid";
   }

   public String getDetailRelatecolname() {
      return "salesid";
   }

   public String getSaveCommandString() {
      return "Bms_sales_mde.销售发货单管理";
   }

   public Vector<Apinfo> getParamapinfos() {
      Vector<Apinfo> v = new Vector();
      v.add(new Apinfo("发货保管账集合", ""));
      v.add(new Apinfo("销售模式", ""));
      v.add(new Apinfo("配货模式", ""));
      v.add(new Apinfo("结算方式", ""));
      v.add(new Apinfo("重新下传数据至WMS", ""));
      v.add(new Apinfo("准许出库配货", ""));
      v.add(new Apinfo("自动出库配货", ""));
      v.add(new Apinfo("自动出库记保管账", ""));
      v.add(new Apinfo("自动缺货登记", ""));
      v.add(new Apinfo("库存是否选择到批号、批次、货位由销售控制", ""));
      v.add(new Apinfo("库存选择到批号", ""));
      v.add(new Apinfo("库存选择到批次", ""));
      v.add(new Apinfo("库存选择到货位", ""));
      v.add(new Apinfo("库存选择到货品状态", ""));
      v.add(new Apinfo("自提允许配货", ""));
      v.add(new Apinfo("禁止审批", "1"));
      v.add(new Apinfo("禁止确定", "1"));
      v.add(new Apinfo("禁止回退提交", ""));
      v.add(new Apinfo("禁止作废", ""));
      v.add(new Apinfo("是否提示选择老批次", "1"));
      v.add(new Apinfo("非严格控制批次限销", ""));
      v.add(new Apinfo("Hov显示价格类型", ""));
      v.add(new Apinfo("是否提示老批号", ""));
      v.add(new Apinfo("发货单确定时不生成销售结算单", ""));
      v.add(new Apinfo("采集序列号", ""));
      v.add(new Apinfo("是否业务员开票 ", ""));
      v.add(new Apinfo("大库保管账", ""));
      return v;
   }

   protected int on_actionPerformed(String arg0) {
      String customid;
      if (arg0.equals("审批")) {
         customid = this.getApvalue("禁止审批");
         if ("1".equals(customid)) {
            this.infoMessage("提示", "没有审批权限不能审批！");
            return -1;
         } else {
            this.approve();
            return 0;
         }
      } else {
         if (arg0.equals("重新下传数据至WMS")) {
            customid = this.getApvalue("重新下传数据至WMS");
            if (!"1".equals(customid)) {
               this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
               return -1;
            }

            this.again();
         } else {
            String entryid;
            if (arg0.equals("选择医院订单")) {
               customid = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "hisorderid");
               if (customid.endsWith("***")) {
                  this.warnMessage("警告", "已经选择***订单，不能再选择！");
                  return -1;
               }

               entryid = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "vendorid");
               if (!entryid.equals("")) {
                  int j = JOptionPane.showConfirmDialog(this.frame, "所选总单已经选择过订单，是否重新选择", "提示信息", 1);
                  if (j != 0) {
                     return -1;
                  }
               }

               this.choseorder();
            } else {
               Exception e;
               if (arg0.equals("确定")) {
                  if ("1".equals(this.getApvalue("禁止确定"))) {
                     this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
                     return -1;
                  }

                  try {
                     this.confirm(true);
                     return 0;
                  } catch (Exception var12) {
                     e = var12;
                     e.printStackTrace();
                     this.infoMessage("提示", "确定出错!" + e.getMessage());
                     return -1;
                  }
               }

               if (arg0.equals("回退确定")) {
                  if ("1".equals(this.getApvalue("禁止回退确定"))) {
                     this.unconfirm();
                     return 0;
                  }

                  this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
                  return -1;
               }

               if (arg0.equals("作废")) {
                  if ("1".equals(this.getApvalue("禁止作废"))) {
                     this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
                     return -1;
                  }

                  this.invalid();
                  return 0;
               }

               if (arg0.equals("切换独立单元")) {
                  if (this.mastermodel.getModifiedDbmodel().getRowCount() > 0) {
                     this.infoMessage("提示", "有尚未保存的数据，请先作保存！");
                     return -1;
                  }

                  if (Entrychose.setUserEntryInfo(this.frame)) {
                     this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
                     this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
                     this.getMasterModel().doRetrieve("1=2");
                     this.nosapriceinfo = NpbusiDBHelper.getSysParaConfig(this.entryid, "nosapriceinfo");
                  }

                  return 0;
               }

               if (arg0.equals("回退提交")) {
                  if ("1".equals(this.getApvalue("禁止回退提交"))) {
                     this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
                     return -1;
                  }

                  this.backSubmit();
                  return 0;
               }

               String usestatus;
               String companyid;
               if ("采集序列号".equals(arg0)) {
                  try {
                     if (!"1".equals(this.getApvalue("采集序列号"))) {
                        this.infoMessage("提示", "对不起，您没有执行该操作的权限！");
                        return -1;
                     }

                     int mrow = this.mastermodel.getRow();
                     if (mrow < 0) {
                        this.warnMessage("提示", "请先选择一条总单");
                        return -1;
                     }

                     int dbstatus = this.mastermodel.getdbStatus(mrow);
                     if (dbstatus != 0) {
                        this.warnMessage("提示", "单据尚未保存，请先做保存!~");
                        return -1;
                     }

                     int[] drow = this.detailmodel.getTable().getSelectedRows();
                     int dlen = drow.length;
                     if (dlen != 1) {
                        this.warnMessage("提示", "请先选择一条细单进行采集!");
                        return -1;
                     }

                     String satypeid = this.mastermodel.getItemValue(mrow, "satypeid");
                     companyid = this.mastermodel.getItemValue(mrow, "companyid");
                     usestatus = this.mastermodel.getItemValue(mrow, "usestatus");
                     if (usestatus.trim().equals("1")) {
                        this.infoMessage("提示", "正式状态单据不能修改序列号");
                        return -1;
                     }

                     String goodsqty = this.detailmodel.getItemValue(drow[0], "goodsuseqty");
                     if (DecimalHelper.comparaDecimal("0", goodsqty) >= 1) {
                        this.infoMessage("提示", "数量不能小于0");
                        return -1;
                     }

                     String storageid = this.mastermodel.getItemValue(mrow, "storageid");
                     if (storageid != null && storageid.trim().length() > 0) {
                        boolean wmsflag = NptrDBHelper.checkWmsflag(storageid, this.entryid);
                        if (wmsflag) {
                           this.infoMessage("提示", "物流保管帐不能采集序列号");
                           return -1;
                        }

                        this.inputeSequence(companyid, satypeid, drow[0], goodsqty);
                     }
                  } catch (Exception var13) {
                     e = var13;
                     logger.error("error", e);
                     this.errorMessage("错误", e.getMessage());
                  }

                  return 0;
               }

               if (arg0.startsWith("DOCPRINT_")) {
                  customid = this.mastermodel.getItemValue(this.mastermodel.getRow(), "customid");
                  entryid = this.mastermodel.getItemValue(this.mastermodel.getRow(), "entryid");
                  String sql = " select a.printmodelname\n  from zx_printclientmodel a, pub_entry_customer b\n where a.clientid = b.customid\n   and a.entryid=b.entryid    and b.entryid = " + entryid + "   and a.printmodeltype = 2 " + "   and a.clientid = " + customid;
                  RemotesqlHelper sqlh = new RemotesqlHelper();
                  DBTableModel model = null;

                  try {
                     model = sqlh.doSelect(sql, 0, 1);
                     if (model != null && model.getRowCount() > 0) {
                        companyid = String.valueOf(String.valueOf(String.valueOf(model.getItemValue(0, "printmodelname")))) + ".printplan";
                        new File("conf/" + companyid);
                        Printplan plan2 = new Printplan("", "");
                        plan2.setForbidreprint(false);
                        File configfile2 = new File("打印方案/" + companyid);
                        Printplan.downloadPrintplan(configfile2);
                        plan2.read(configfile2);
                        plan2.setInputparam(this.mastermodel.getItemValue(this.mastermodel.getRow(), "salesid"));
                        plan2.getParts().prepareData();
                        plan2.sendPrinter();
                        return 0;
                     }

                     companyid = arg0.replace("DOCPRINT_", "");
                     usestatus = String.valueOf(String.valueOf(String.valueOf(companyid))) + ".printplan";
                     new File("conf/" + usestatus);
                     Printplan plan = new Printplan("", "");
                     plan.setForbidreprint(false);
                     File configfile = new File("打印方案/" + usestatus);
                     Printplan.downloadPrintplan(configfile);
                     plan.read(configfile);
                     plan.setInputparam(this.mastermodel.getItemValue(this.mastermodel.getRow(), "salesid"));
                     plan.getParts().prepareData();
                     plan.sendPrinter();
                     return 0;
                  } catch (Exception var14) {
                     Exception e2 = var14;
                     e2.printStackTrace();
                     usestatus = e2.getMessage();
                     if (usestatus.contains("找不到打印方案文件")) {
                        this.infoMessage("提示", usestatus);
                     }

                     System.err.println(entryid);
                     return super.on_actionPerformed(arg0);
                  }
               }

               if (arg0.startsWith("驳回")) {
                  this.reject();
               } else if (arg0.startsWith("销售转单补录")) {
                  this.genDkSu();
               } else if (arg0.startsWith("生成京润订单")) {
                  this.genDkJrSu();
               } else if (arg0.startsWith("修改运输地址")) {
                  this.changeTrans();
               }
            }
         }

         return super.on_actionPerformed(arg0);
      }
   }

   private void changeTrans() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行单据生成!");
      } else {
         for(int i = 0; i < this.getMasterModel().getRowCount(); ++i) {
            if (this.getMasterModel().getdbStatus(i) != 0) {
               this.warnMessage("警告", "请先保存!");
               return;
            }
         }

         String usestatus = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
         String salesid = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "salesid");
         String customid = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "customid");
         if (!"2".equals(usestatus)) {
            this.warnMessage("警告", "销售发货单不是临时状态，不能修改！");
         } else {
            Bms_tr_pos_hov hov = new Bms_tr_pos_hov(true);
            hov.setOtherwheres("COMPANYID = " + customid);
            DBTableModel result = hov.showDialog(this.frame, "");
            String tranposid = "";
            String tranposname = "";
            if (!ObjectUtils.isNULL(result) && result.getRowCount() > 0) {
               tranposid = result.getItemValue(0, "tranposid");
               tranposname = result.getItemValue(0, "tranposname");
               ClientRequest req = new ClientRequest();
               StringCommand sc = new StringCommand("Bms_sales_mde.换运输地址");
               req.addCommand(sc);
               req.addCommand(new StringCommand(salesid));
               req.addCommand(new StringCommand(tranposid));
               ServerResponse resp = null;

               try {
                  resp = SendHelper.sendRequest(req);
                  StringCommand sc2 = (StringCommand)resp.commandAt(0);
                  if (sc2.getString().startsWith("+OK")) {
                     this.infoMessage("提示", "换运输地址成功！");
                     this.getMasterModel().setItemValue(this.getMasterModel().getRow(), "targetposid", tranposid);
                     this.getMasterModel().setItemValue(this.getMasterModel().getRow(), "targetname", tranposname);
                     this.getMasterModel().setdbStatus(this.getMasterModel().getRow(), 0);
                     this.getMasterModel().tableChanged();
                  } else {
                     this.errorMessage("错误", "换运输地址不成功原因:" + sc2.getString());
                  }
               } catch (Exception var12) {
                  Exception e = var12;
                  this.errorMessage("错误", "换运输地址不成功原因:" + e.getMessage());
                  e.printStackTrace();
               }
            }

         }
      }
   }

   private void genDkJrSu() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行单据生成!");
      } else {
         for(int i = 0; i < this.getMasterModel().getRowCount(); ++i) {
            if (this.getMasterModel().getdbStatus(i) != 0) {
               this.warnMessage("警告", "请先保存!");
               return;
            }
         }

         String usestatus = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
         String salesid = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "salesid");
         if (!"1".equals(usestatus)) {
            this.warnMessage("警告", "销售发货单不是确定状态，不能进行单据生成！");
         } else {
            ClientRequest req = new ClientRequest();
            StringCommand sc = new StringCommand("Bms_sales_mde.生成德康京润采购订单");
            req.addCommand(sc);
            req.addCommand(new StringCommand(salesid));
            ServerResponse resp = null;

            try {
               resp = SendHelper.sendRequest(req);
               StringCommand sc2 = (StringCommand)resp.commandAt(0);
               if (sc2.getString().startsWith("+OK")) {
                  this.infoMessage("提示", "转单成功！");
               } else {
                  this.errorMessage("错误", "转单不成功原因:" + sc2.getString());
               }
            } catch (Exception var7) {
               Exception e = var7;
               this.errorMessage("错误", "转单不成功原因:" + e.getMessage());
               e.printStackTrace();
            }

         }
      }
   }

   private void genDkSu() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行单据生成!");
      } else {
         for(int i = 0; i < this.getMasterModel().getRowCount(); ++i) {
            if (this.getMasterModel().getdbStatus(i) != 0) {
               this.warnMessage("警告", "请先保存!");
               return;
            }
         }

         String usestatus = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
         String salesid = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "salesid");
         if (!"1".equals(usestatus)) {
            this.warnMessage("警告", "销售发货单不是确定状态，不能进行单据生成！");
         } else {
            ClientRequest req = new ClientRequest();
            StringCommand sc = new StringCommand("Bms_sales_mde.生成德康采购订单");
            req.addCommand(sc);
            req.addCommand(new StringCommand(salesid));
            ServerResponse resp = null;

            try {
               resp = SendHelper.sendRequest(req);
               StringCommand sc2 = (StringCommand)resp.commandAt(0);
               if (sc2.getString().startsWith("+OK")) {
                  this.infoMessage("提示", "转单成功！");
               } else {
                  this.errorMessage("错误", "转单不成功原因:" + sc2.getString());
               }
            } catch (Exception var7) {
               Exception e = var7;
               this.errorMessage("错误", "转单不成功原因:" + e.getMessage());
               e.printStackTrace();
            }

         }
      }
   }

   private String ues(String flag) {
      String entryid = ClientUserManager.getCurrentUser().getEntryid();
      String sql = "select * from pub_entry t where t.entryid = " + entryid;
      RemotesqlHelper rh = new RemotesqlHelper();
      DBTableModel model = null;

      try {
         model = rh.doSelect(sql, 0, 1);
         String useflag = model.getItemValue(0, "useflag");
         if (useflag.length() > 0) {
            flag = "1";
         }
      } catch (Exception var7) {
         Exception e = var7;
         e.printStackTrace();
      }

      return flag;
   }

   private void choseorder() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行审批!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行审批!");
      } else if (!this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus").equals("1")) {
         this.warnMessage("警告", "非正式状态禁止选择医院订单!");
      } else {
         int rowCount = this.getDetailModel().getRowCount();
         String string = "";
         String customid = this.getMasterModel().getItemValue(0, "customid");

         for(int i = 0; i < rowCount; ++i) {
            String goodsid = this.getDetailModel().getItemValue(i, "goodsid");
            String goodsname = this.getDetailModel().getItemValue(i, "goodsname");
            if (CheckHelper.CheckGoods(goodsid, customid).equals("检查失败")) {
               string = String.valueOf(String.valueOf(String.valueOf(String.valueOf(string)))) + "第" + (i + 1) + "行货品:" + goodsname + ", 未对照,请先对照 \n";
            }
         }

         Bms_chose_order_hov bms_chose_order_hov = new Bms_chose_order_hov();
         System.out.println();
         if (customid.equals("18881") || customid.equals("18882") || customid.equals("18883") || customid.equals("18884")) {
            customid = "861";
         }

         bms_chose_order_hov.setOtherwheres("  yljgbm=" + customid);
         DBTableModel showDialog;
         if ((showDialog = bms_chose_order_hov.showDialog((Frame)null, "选择医院订单")) != null) {
            boolean flag = true;
            DBTableModel xdModel = null;
            String docid;
            String goodsid3;
            RemotesqlHelper resp;
            Exception e2;
            if (customid.equals("12297") || customid.equals("862") || customid.equals("18612") || customid.equals("20241")) {
               docid = showDialog.getItemValue(0, "docid");
               goodsid3 = "SELECT goodsid FROM MID2ERP_OUT_DTL_V where docid = " + docid + " and goodsid is not null GROUP BY goodsid HAVING count(1) > 1";
               boolean cfFlag = false;
               DBTableModel fmodel = null;
               resp = new RemotesqlHelper();

               try {
                  fmodel = resp.doSelect(goodsid3, 0, 1000);
               } catch (Exception var19) {
                  e2 = var19;
                  e2.printStackTrace();
               }

               StringBuffer sqlBuffer = new StringBuffer();
               if (fmodel != null && fmodel.getRowCount() > 0) {
                  for(int j = 0; j < rowCount; ++j) {
                     String tmpGoodsId = this.getDetailModel().getItemValue(j, "goodsid");

                     for(int k = 0; k < fmodel.getRowCount(); ++k) {
                        String goodsid2 = fmodel.getItemValue(k, "goodsid");
                        if (tmpGoodsId.equals(goodsid2)) {
                           cfFlag = true;
                           flag = false;
                           sqlBuffer.append(goodsid2).append(",");
                        }
                     }
                  }
               }

               if (cfFlag) {
                  String string2 = sqlBuffer.toString();
                  string2 = string2.substring(0, string2.length() - 1);
                  Bms_chose_xd_order_hov xdhov = new Bms_chose_xd_order_hov();
                  xdhov.setOtherwheres("  docid=" + docid + " and goodsid in(" + string2 + ") ");
                  xdModel = xdhov.showDialog((Frame)null, "选择医院订单细单");
               }
            }

            docid = "";
            goodsid3 = "";
            if (xdModel != null && xdModel.getRowCount() > 0) {
               docid = xdModel.getItemValue(0, "dtlid");
               goodsid3 = xdModel.getItemValue(0, "goodsid");
            }

            if (flag || !"".equals(docid) && docid != null) {
               String usestatus = showDialog.getItemValue(0, "usestatus");
               if (!usestatus.equals("正式") || JOptionPane.showConfirmDialog((Component)null, "医院订单为正式，是否确定?", "确定", 0) == 0) {
                  ClientRequest clientRequest = new ClientRequest("bms_sales_mde.选择医院订单");
                  clientRequest.addCommand(new StringCommand(showDialog.getItemValue(0, "vendorid")));
                  clientRequest.addCommand(new StringCommand(showDialog.getItemValue(0, "hisorderid")));
                  clientRequest.addCommand(new StringCommand(showDialog.getItemValue(0, "storageid")));
                  clientRequest.addCommand(new StringCommand(this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "salesid")));
                  clientRequest.addCommand(new StringCommand(showDialog.getItemValue(0, "sutype")));
                  clientRequest.addCommand(new StringCommand(docid));
                  clientRequest.addCommand(new StringCommand(goodsid3));
                  clientRequest.addCommand(new StringCommand(customid));
                  resp = null;

                  try {
                     ServerResponse resp = SendHelper.sendRequest(clientRequest);
                     StringCommand sc2 = (StringCommand)resp.commandAt(0);
                     if (sc2.getString().startsWith("+OK")) {
                        this.getMasterModel().setItemValue(this.getMasterModel().getRow(), "vendorid", showDialog.getItemValue(0, "vendorid"));
                        this.getMasterModel().setItemValue(this.getMasterModel().getRow(), "hisorderid", showDialog.getItemValue(0, "hisorderid"));
                        this.getMasterModel().setItemValue(this.getMasterModel().getRow(), "storageid", showDialog.getItemValue(0, "storageid"));
                        this.getMasterModel().setdbStatus(this.getMasterModel().getRow(), 0);
                        this.infoMessage("提示", "操作成功");
                        return;
                     }

                     this.infoMessage("提示", "操作失败" + sc2);
                  } catch (Exception var18) {
                     e2 = var18;
                     e2.printStackTrace();
                     this.errorMessage("错误", "不成功原因:" + e2.getMessage());
                     this.mastermodel.doRequery();
                  }

               }
            }
         }
      }
   }

   private void again() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行审批!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行审批!");
      } else {
         int rows = this.mastermodel.getTable().getSelectedRow();
         String salesid = this.mastermodel.getItemValue(rows, "salesid");
         String sql = " select towmsflag from bms_sa_doc where salesid= " + salesid;
         RemotesqlHelper sqlh = new RemotesqlHelper();
         DBTableModel model = null;

         try {
            model = sqlh.doSelect(sql, 0, 1);
         } catch (Exception var15) {
            Exception e = var15;
            e.printStackTrace();
         }

         String towmsflag = model.getItemValue(0, "towmsflag");
         String usestatus = this.mastermodel.getItemValue(rows, "usestatus");
         if (!usestatus.equals("1")) {
            this.warnMessage("警告", "总单状态不是正式状态，不能重新下发！");
         } else if ("2".equals(towmsflag)) {
            this.warnMessage("警告", "已经下发2次了，不能重新下发！");
         } else {
            String sysdate = NpbusiDBHelper.getSysdate();
            ClientRequest req = new ClientRequest();
            StringCommand sc = new StringCommand("销售发货单重新下传wms");
            ParamCommand paramcmd = new ParamCommand();
            paramcmd.addParam("salesid", salesid);
            paramcmd.addParam("sysdate", sysdate);
            req.addCommand(sc);
            req.addCommand(paramcmd);
            ServerResponse resp = null;

            try {
               resp = SendHelper.sendRequest(req);
               StringCommand sc2 = (StringCommand)resp.commandAt(0);
               if (sc2.getString().startsWith("+OK")) {
                  this.infoMessage("提示", "重新下传成功!");
                  this.mastermodel.doRequery();
               } else {
                  this.infoMessage("提示", "确定失败或下发wms失败,原因:" + sc2);
                  this.mastermodel.doRequery();
               }
            } catch (Exception var14) {
               Exception e2 = var14;
               e2.printStackTrace();
               this.errorMessage("错误", "不成功原因:" + e2.getMessage());
               this.mastermodel.doRequery();
            }

         }
      }
   }

   private void reject() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行审批!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行审批!");
      } else {
         for(int i = 0; i < this.getMasterModel().getRowCount(); ++i) {
            if (this.getMasterModel().getdbStatus(i) != 0) {
               this.warnMessage("警告", "没有保存不能审批,请先保存!");
               return;
            }
         }

         String usestatus = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
         if (!"2".equals(usestatus)) {
            this.warnMessage("警告", "销售发货单不是临时状态，不能审批！");
         } else {
            String approveflag = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "approveflag");
            if (!"2".equals(approveflag)) {
               this.warnMessage("警告", "销售发货单不是待审批状态，不能审批！");
            } else {
               Bms_sales_app_rejected_hov hov = new Bms_sales_app_rejected_hov();
               DBTableModel hovmodel = hov.showDialog(this.getParentFrame(), "选择驳回原因");
               if (hovmodel != null) {
                  String rejectMemo = hovmodel.getItemValue(0, "ddlname");
                  DBTableModel tmpdbmodel = createRejectdbmodel();
                  int[] selectrows = this.getMasterModel().getTable().getSelectedRows();

                  for(int j = 0; j < selectrows.length; ++j) {
                     String salesid = this.getMasterModel().getItemValue(selectrows[j], "salesid");
                     tmpdbmodel.appendRow();
                     int row = tmpdbmodel.getRowCount();
                     tmpdbmodel.setItemValue(row - 1, "salesid", salesid);
                     tmpdbmodel.setItemValue(row - 1, "rejectMemo", rejectMemo);
                  }

                  ClientRequest req = new ClientRequest();
                  StringCommand sc = new StringCommand("Bms_sales_mde.审批_驳回");
                  DataCommand dcmd = new DataCommand();
                  dcmd.setDbmodel(tmpdbmodel);
                  req.addCommand(sc);
                  req.addCommand(dcmd);
                  ServerResponse resp = null;

                  try {
                     resp = SendHelper.sendRequest(req);
                     StringCommand sc2 = (StringCommand)resp.commandAt(0);
                     if (sc2.getString().startsWith("+OK")) {
                        this.infoMessage("提示", "审批成功！");
                        DataCommand respdcmd = (DataCommand)resp.commandAt(1);
                        DBTableModel tmpdbmodel2 = respdcmd.getDbmodel();
                        DBTableModel mdbmodel = this.getMasterModel().getDBtableModel();

                        for(int a = 0; a < tmpdbmodel2.getRowCount(); ++a) {
                           String rejectmemo = tmpdbmodel2.getItemValue(0, "rejectmemo");
                           String salesid2 = tmpdbmodel2.getItemValue(0, "salesid");
                           String appflag = tmpdbmodel2.getItemValue(0, "approveflag");

                           for(int k = 0; k < mdbmodel.getRowCount(); ++k) {
                              String tmpsalesid = mdbmodel.getItemValue(k, "salesid");
                              if (tmpsalesid.equals(salesid2)) {
                                 this.getMasterModel().setItemValue(k, "rejectmemo", rejectmemo);
                                 this.getMasterModel().setItemValue(k, "approveflag", appflag);
                                 this.getMasterModel().setdbStatus(k, 0);
                                 this.getMasterModel().tableChanged();
                              }
                           }
                        }
                     } else {
                        this.errorMessage("错误", "审批不成功原因:" + sc2.getString());
                     }
                  } catch (Exception var22) {
                     Exception e = var22;
                     this.errorMessage("错误", "审批不成功原因:" + e.getMessage());
                     e.printStackTrace();
                  }

               }
            }
         }
      }
   }

   private void approve() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行审批!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行审批!");
      } else {
         for(int i = 0; i < this.getMasterModel().getRowCount(); ++i) {
            if (this.getMasterModel().getdbStatus(i) != 0) {
               this.warnMessage("警告", "没有保存不能审批,请先保存!");
               return;
            }
         }

         String usestatus = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
         if (!"2".equals(usestatus)) {
            this.warnMessage("警告", "销售发货单不是临时状态，不能审批！");
         } else {
            String approveflag = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "approveflag");
            if (!"2".equals(approveflag)) {
               this.warnMessage("警告", "销售发货单不是待审批状态，不能审批！");
            } else {
               String salesid = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "salesid");
               String commitcheckinfo = "";
               DBTableModel model = null;
               String sql = " select savememo from bms_sa_approve_memo where sourceid= " + salesid + " and comefrom = 2";
               RemotesqlHelper sqlh = new RemotesqlHelper();

               try {
                  model = sqlh.doSelect(sql, 0, 1);
               } catch (Exception var17) {
                  Exception e = var17;
                  e.printStackTrace();
               }

               if (model != null && model.getRowCount() > 0) {
                  commitcheckinfo = model.getItemValue(0, "savememo");
               }

               ClientRequest req = new ClientRequest();
               StringCommand sc = new StringCommand("Bms_sales_mde.销售发货单提交");
               DBTableModel tmpdbmodel = createCheckParamdbmodel();
               tmpdbmodel.appendRow();
               tmpdbmodel.setItemValue(0, "salesid", salesid);
               tmpdbmodel.setItemValue(0, "isCommit", "0");
               DataCommand dcmd = new DataCommand();
               dcmd.setDbmodel(tmpdbmodel);
               req.addCommand(sc);
               req.addCommand(dcmd);
               ServerResponse resp = null;

               try {
                  resp = SendHelper.sendRequest(req);
                  StringCommand sc2 = (StringCommand)resp.commandAt(0);
                  if (sc2.getString().startsWith("+OK")) {
                     DataCommand respdcmd = (DataCommand)resp.commandAt(1);
                     tmpdbmodel = respdcmd.getDbmodel();
                     String approvememo = tmpdbmodel.getItemValue(0, "approvememo");
                     (this.dialog = new ApproveDialog(this.frame, "销售发货单审批", this)).pack();
                     this.dialog.setLocation((int)((Toolkit.getDefaultToolkit().getScreenSize().getWidth() - (double)this.dialog.getWidth()) / 2.0), (int)((Toolkit.getDefaultToolkit().getScreenSize().getHeight() - (double)this.dialog.getHeight()) / 2.0));
                     this.dialog.setVisible(true);
                     this.dialog.getappcheckarea().setText(approvememo);
                     this.dialog.getcommitcheckarea().setText(commitcheckinfo);
                  } else {
                     this.errorMessage("错误", "审批不成功原因:" + sc2.getString());
                  }
               } catch (Exception var16) {
                  Exception e2 = var16;
                  this.errorMessage("错误", "审批不成功原因:" + e2.getMessage());
                  e2.printStackTrace();
               }

            }
         }
      }
   }

   private void unconfirm() {
      int[] rows = this.mastermodel.getTable().getSelectedRows();
      if (rows.length == 0) {
         this.infoMessage("提示", "请选择单据");
      }

      DBTableModel tmpdbmodel = createUnConfirmParamdbmodel();

      int i;
      String salesid;
      for(i = 0; i < rows.length; ++i) {
         String usestatus = this.getMasterModel().getItemValue(rows[i], "usestatus");
         if (!"1".equals(usestatus)) {
            this.warnMessage("警告", "销售发货单不是正式状态，不能回退确定！");
            return;
         }

         String comefrom = this.getMasterModel().getItemValue(rows[i], "comefrom");
         if (!"1".equals(comefrom)) {
            this.warnMessage("警告", "销售发货单不是手工录入，不能回退确定！");
            return;
         }

         salesid = this.getMasterModel().getItemValue(rows[i], "salesid");
         tmpdbmodel.appendRow();
         tmpdbmodel.setItemValue(i, "salesid", salesid);
      }

      for(i = 0; i < this.getMasterModel().getRowCount(); ++i) {
         if (this.getMasterModel().getdbStatus(i) != 0) {
            this.warnMessage("警告", "没有保存不能回退确定,请先保存!");
            return;
         }
      }

      ClientRequest req = new ClientRequest();
      StringCommand sc = new StringCommand("Bms_sales_mde.销售发货单回退确定");
      DataCommand dcmd = new DataCommand();
      dcmd.setDbmodel(tmpdbmodel);
      req.addCommand(sc);
      req.addCommand(dcmd);
      this.setWaitCursor();
      salesid = null;

      label93: {
         try {
            ServerResponse resp = SendHelper.sendRequest(req);
            this.setStatus(resp, "回退确定", 2, 5);
            break label93;
         } catch (Exception var11) {
            Exception e = var11;
            this.errorMessage("错误", "回退确定不成功原因:" + e.getMessage());
            e.printStackTrace();
         } finally {
            this.setDefaultCursor();
         }

         return;
      }

      this.setDefaultCursor();
      this.setDefaultCursor();
      this.setDefaultCursor();
   }

   private void invalid() {
      int row = this.getMasterModel().getRow();
      if (row >= 0 && row != this.getMasterModel().getDBtableModel().getRowCount()) {
         for(int i = 0; i < this.getMasterModel().getRowCount(); ++i) {
            if (this.getMasterModel().getdbStatus(i) != 0) {
               this.warnMessage("警告", "没有保存不能作废,请先保存!");
               return;
            }
         }

         if (this.getDetailModel().getRow() < 0) {
            this.warnMessage("警告", "请选择正确的单据进行作废!");
         } else if (this.getDetailModel().getRow() == this.getDetailModel().getDBtableModel().getRowCount()) {
            this.warnMessage("警告", "请选择正确的单据进行作废!");
         } else {
            int[] dtlrows = this.getDetailModel().getTable().getSelectedRows();
            int rowCount = dtlrows.length;
            if (this.getDetailModel().getTable().getSelectedRow() == this.getDetailModel().getTable().getRowCount() - 1) {
               this.warnMessage("警告", "选中行错误,请重新选择!!!");
            } else {
               String masusestatus = this.getMasterModel().getItemValue(row, "usestatus");
               if (masusestatus != null && !"1".equals(masusestatus.trim())) {
                  this.infoMessage("提示", "只有正式状态的单据才能作废");
               } else {
                  if (dtlrows[dtlrows.length - 1] == this.getDetailModel().getRowCount()) {
                     --rowCount;
                  }

                  String salesid = this.getMasterModel().getItemValue(row, "salesid");
                  DBTableModel tmpdbmodel = createInvalidParamdbmodel();

                  String usestatus;
                  String eror;
                  String dtlErId;
                  for(int j = 0; j < rowCount; ++j) {
                     if (this.getDetailModel().getdbStatus(dtlrows[j]) != 0) {
                        this.warnMessage("警告", "第" + (dtlrows[j] + 1) + "行细单没有保存不能作废,请先保存!");
                        return;
                     }

                     String salesdtlid = this.getDetailModel().getItemValue(dtlrows[j], "salesdtlid");
                     usestatus = "";
                     DBTableModel model = null;
                     eror = " SELECT c.usestatus FROM bms_sa_doctoset a ,bms_sa_settle_dtl b,bms_sa_settle_doc c  WHERE a.sasettledtlid=b.sasettledtlid AND b.sasettleid=c.sasettleid AND a.salesdtlid=" + salesdtlid + " ";
                     RemotesqlHelper sqlh = new RemotesqlHelper();

                     try {
                        model = sqlh.doSelect(eror, 0, 1);
                     } catch (Exception var22) {
                        Exception e = var22;
                        e.printStackTrace();
                     }

                     if (model != null && model.getRowCount() > 0) {
                        usestatus = model.getItemValue(0, "usestatus");
                        if (usestatus.equals("1")) {
                           this.warnMessage("警告", "第" + (dtlrows[j] + 1) + "行细单已结算确认,不能作废！");
                           return;
                        }
                     }

                     String correctflag = this.detailmodel.getItemValue(dtlrows[j], "correctflag");
                     if (!correctflag.equals("0")) {
                        this.warnMessage("警告", "第" + (dtlrows[j] + 1) + "行细单的冲调标志不是\"正常\"状态,不能作废！");
                        return;
                     }

                     dtlErId = this.getDetailModel().getItemValue(dtlrows[j], "stioflag");
                     if ("1".equals(dtlErId)) {
                        this.warnMessage("警告", "第" + (dtlrows[j] + 1) + "行细单已经出库记账,不能作废！");
                        return;
                     }

                     int newr = tmpdbmodel.getRowCount();
                     tmpdbmodel.appendRow();
                     tmpdbmodel.setItemValue(newr, "salesid", salesid);
                     tmpdbmodel.setItemValue(newr, "salesdtlid", salesdtlid);
                  }

                  if (tmpdbmodel.getRowCount() > 0) {
                     ClientRequest req = new ClientRequest();
                     DataCommand dcmd = new DataCommand();
                     dcmd.setDbmodel(tmpdbmodel);
                     req.addCommand(new StringCommand("Bms_sales_mde.销售发货单作废"));
                     req.addCommand(dcmd);
                     this.setWaitCursor();
                     usestatus = null;

                     label250: {
                        try {
                           ServerResponse resps = SendHelper.sendRequest(req);
                           StringCommand sc2 = (StringCommand)resps.commandAt(0);
                           eror = "";
                           if (!sc2.getString().startsWith("+OK")) {
                              this.errorMessage("错误", "作废不成功,原因:" + sc2.getString());
                           } else {
                              DataCommand respdcmd = (DataCommand)resps.commandAt(1);
                              DBTableModel dbmodel = respdcmd.getDbmodel();
                              dtlErId = "";
                              boolean preparestatus = false;

                              for(int k = 0; k < dbmodel.getRowCount(); ++k) {
                                 String message;
                                 if (!preparestatus) {
                                    message = dbmodel.getItemValue(k, "preparestatus");
                                    if (message != null && message.equals("1")) {
                                       preparestatus = true;
                                    }
                                 }

                                 message = dbmodel.getItemValue(k, "message");
                                 eror = String.valueOf(String.valueOf(String.valueOf(message))) + "\n";
                                 if (!message.startsWith("+OK")) {
                                    dtlErId = String.valueOf(String.valueOf(String.valueOf(dtlErId))) + dbmodel.getItemValue(k, "salesdtlid") + "、";
                                 }
                              }

                              if ("".equals(dtlErId)) {
                                 if (preparestatus) {
                                    this.infoMessage("提示", "作废成功!\n库房已经配货，请立即通知库房！");
                                 } else {
                                    this.infoMessage("提示", "作废成功！");
                                 }
                              } else {
                                 this.infoMessage("提示", "ID为" + dtlErId.substring(0, dtlErId.length() - 1) + "的细单作废失败！\n" + eror);
                              }
                           }
                        } catch (Exception var23) {
                           var23.printStackTrace();
                           this.errorMessage("错误", "作废不成功,原因:" + var23.getMessage());
                           break label250;
                        } finally {
                           this.setDefaultCursor();
                        }

                        this.setDefaultCursor();
                        this.setDefaultCursor();
                        this.setDefaultCursor();
                     }

                     this.getMasterModel().doRequery();
                  }
               }
            }
         }
      } else {
         this.warnMessage("警告", "请选择正确的单据进行作废!");
      }
   }

   private void confirm(boolean checkPrice) throws Exception {
      String entryid = ClientUserManager.getCurrentUser().getEntryid();
      String autokeep = this.getApvalue("自动出库记保管账");

      for(int i = 0; i < this.getMasterModel().getRowCount(); ++i) {
         if (this.getMasterModel().getdbStatus(i) != 0) {
            this.warnMessage("警告", "没有保存不能确定,请先保存!");
            return;
         }
      }

      DBTableModel tmpdbmodel = createConfirmParamdbmodel();
      DBTableModel docmodel = this.getMasterModel().getDBtableModel();
      DBTableModel dtlmodel = this.getDetailModel().getDBtableModel();
      int[] rows = this.mastermodel.getTable().getSelectedRows();
      int swaprowNo = 0;

      for(int j = 0; j < rows.length; ++j) {
         String approveflag = this.getMasterModel().getItemValue(rows[j], "approveflag");
         String usestatus = this.getMasterModel().getItemValue(rows[j], "usestatus");
         String satypeid = this.getMasterModel().getItemValue(rows[j], "satypeid");
         if ("2".equals(approveflag)) {
            this.warnMessage("警告", "请先审批！");
            return;
         }

         if (!"2".equals(usestatus)) {
            if (checkPrice) {
               this.warnMessage("警告", "不是临时状态，不能确定！");
               return;
            }
         } else {
            boolean confirmflag = true;
            boolean autoflag = true;
            boolean gatherflag = false;
            boolean auto = false;
            String storageid = this.getMasterModel().getItemValue(rows[j], "storageid");
            boolean wmsflag = this.checkWmsFlag(storageid, entryid);
            if (!wmsflag) {
               dtlmodel = this.getDetaildbmodel(rows[j]);
               if (dtlmodel != null && dtlmodel.getRowCount() > 0) {
                  int k;
                  for(k = 0; k < dtlmodel.getRowCount(); ++k) {
                     String goodsid = dtlmodel.getItemValue(k, "goodsid");
                     boolean sequenceflag = NptrDBHelper.checkGoodsSeqFlag(goodsid, entryid);
                     if (sequenceflag) {
                        String goodsqty = dtlmodel.getItemValue(k, "goodsqty");
                        String salesdtlid = dtlmodel.getItemValue(k, "salesdtlid");
                        int comefrom = 0;
                        if (satypeid != null && "1".equals(satypeid)) {
                           comefrom = 3;
                        }

                        if (satypeid != null && "2".equals(satypeid)) {
                           comefrom = 4;
                        }

                        DBTableModel dbmodellst = this.getExistsSequence(goodsid, String.valueOf(comefrom), salesdtlid);
                        String existsSeqNum = String.valueOf(dbmodellst.getRowCount());
                        if (existsSeqNum == null || existsSeqNum.trim().length() == 0) {
                           existsSeqNum = "0";
                        }

                        if (DecimalHelper.comparaDecimal("0", goodsqty) >= 0) {
                           dtlmodel.getRecordThunk(k).setSaveresult(1, String.format("第%s行数据货品数量不能为0", k + 1));
                           return;
                        }

                        if (DecimalHelper.comparaDecimal(goodsqty, existsSeqNum) != 0) {
                           if ("1".equals(autokeep)) {
                              if (DecimalHelper.comparaDecimal(existsSeqNum, "0") == 0) {
                                 dtlmodel.getRecordThunk(k).setSaveresult(1, String.format("第%s行数据货品数量[" + goodsqty + "]没有采集序列号,不能自动出库记账!", k + 1));
                                 auto = true;
                                 confirmflag = true;
                                 gatherflag = true;
                                 autoflag = false;
                                 this.getMasterModel().setItemValue(this.getMasterModel().getRow(), "autoflag", "");
                                 this.getMasterModel().setItemValue(this.getMasterModel().getRow(), "confirmflag", "1");
                              } else {
                                 dtlmodel.getRecordThunk(k).setSaveresult(1, String.format("第%s行数据货品数量[" + goodsqty + "]与采集序列号数量[" + existsSeqNum + "]不符,不能确定和自动出库记账!", k + 1));
                                 auto = true;
                                 confirmflag = false;
                                 autoflag = false;
                                 this.getMasterModel().setItemValue(this.getMasterModel().getRow(), "autoflag", "");
                                 this.getMasterModel().setItemValue(this.getMasterModel().getRow(), "confirmflag", "1");
                              }
                           } else if (DecimalHelper.comparaDecimal(existsSeqNum, "0") == 0) {
                              gatherflag = true;
                           } else {
                              dtlmodel.getRecordThunk(k).setSaveresult(1, String.format("第%s行数据货品数量[" + goodsqty + "]与采集序列号数量[" + existsSeqNum + "]不符，不能确定", k + 1));
                              confirmflag = false;
                              this.getMasterModel().setItemValue(this.getMasterModel().getRow(), "confirmflag", "1");
                           }
                        }
                     }
                  }

                  if (!confirmflag) {
                     this.infoMessage("提示", "细单中有扫描的序列号个数与货品数量不一致的单据请检查");
                     return;
                  }

                  if (gatherflag) {
                     k = JOptionPane.showConfirmDialog((Component)null, "细单中有未采集序列号的单据，是否允许确定?", "确定", 0);
                     if (k != 0) {
                        return;
                     }
                  }
               }

               if (auto) {
                  autokeep = "0";
               }
            }

            tmpdbmodel.appendRow();
            String salesid = this.getMasterModel().getItemValue(rows[j], "salesid");
            tmpdbmodel.setItemValue(swaprowNo, "salesid", salesid);
            tmpdbmodel.setItemValue(swaprowNo, "allowfix", this.getApvalue("准许出库配货"));
            tmpdbmodel.setItemValue(swaprowNo, "autofix", this.getApvalue("自动出库配货"));
            tmpdbmodel.setItemValue(swaprowNo, "autokeep", autokeep);
            tmpdbmodel.setItemValue(swaprowNo, "autofixraise", this.getApvalue("自提允许配货"));
            ++swaprowNo;
         }
      }

      DBTableModel tmodel = createsysdatemodel();
      tmodel.appendRow();
      tmodel.setItemValue(0, "sysdate", NpbusiDBHelper.getSysdate());
      DataCommand dmd = new DataCommand();
      dmd.setDbmodel(tmodel);
      ClientRequest req = new ClientRequest();
      StringCommand sc = new StringCommand("Bms_sales_mde.销售发货单确定");
      DataCommand dcmd = new DataCommand();
      dcmd.setDbmodel(tmpdbmodel);
      DataCommand dcmdoc = new DataCommand();
      dcmdoc.setDbmodel(docmodel);
      DataCommand dcmdtl = new DataCommand();
      dcmdtl.setDbmodel(dtlmodel);
      req.addCommand(sc);
      req.addCommand(dcmd);
      req.addCommand(dcmdoc);
      req.addCommand(dcmdtl);
      req.addCommand(new StringCommand(String.valueOf(checkPrice)));
      req.addCommand(dmd);
      this.setWaitCursor();
      ServerResponse resp = null;

      label210: {
         try {
            resp = SendHelper.sendRequest(req);
            this.setStatus(resp, "确定", 4, 8);
            this.getMasterModel().doRequery();
            break label210;
         } catch (Exception var29) {
            this.errorMessage("错误", "确定不成功原因:" + var29.getMessage());
            var29.printStackTrace();
         } finally {
            this.setDefaultCursor();
         }

         return;
      }

      this.setDefaultCursor();
      this.setDefaultCursor();
      this.setDefaultCursor();
   }

   static DBTableModel createsysdatemodel() {
      Vector<DBColumnDisplayInfo> cols = new Vector();
      DBColumnDisplayInfo col = new DBColumnDisplayInfo("sysdate", "date");
      cols.add(col);
      return new DBTableModel(cols);
   }

   private boolean checkWmsFlag(String storageid, String entryid2) {
      String sql = null;
      RemotesqlHelper rh = null;
      DBTableModel model = null;
      sql = "select a.* from bms_st_def a  where nvl(a.wmsflag,0) = 1 and a.storageid =" + storageid + " and a.entryid=" + storageid;
      rh = new RemotesqlHelper();

      try {
         model = rh.doSelect(sql, 0, 1);
         if (model != null && model.getRowCount() > 0) {
            return true;
         }
      } catch (Exception var7) {
         Exception e = var7;
         e.printStackTrace();
      }

      return false;
   }

   public void actionPerformed(ActionEvent arg0) {
      if (arg0.getActionCommand().equals("diglog-ok")) {
         if (this.dialog.getappacross().isSelected()) {
            this.doapprove(true);
         }

         if (this.dialog.getbackcommit().isSelected()) {
            this.doapprove(false);
         }

         this.dialog.getnoapp().isSelected();
      }

      super.actionPerformed(arg0);
   }

   private void doapprove(boolean flag) {
      String appmemo = this.dialog.getappmemoarea().getText();
      String checkmemo = this.dialog.getappcheckarea().getText();
      String salesid = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "salesid");
      String appflag = "0";
      if (flag) {
         appflag = "1";
      }

      StringCommand sc = new StringCommand("Bms_sales_mde.销售发货单审批");
      ClientRequest req = new ClientRequest();
      DBTableModel tmpdbmodel = createApproveParamdbmodel();
      tmpdbmodel.appendRow();
      tmpdbmodel.setItemValue(0, "salesid", salesid);
      tmpdbmodel.setItemValue(0, "approve", appflag);
      tmpdbmodel.setItemValue(0, "approvememo", appmemo);
      tmpdbmodel.setItemValue(0, "appcheckinfo", checkmemo);
      DataCommand dcmd = new DataCommand();
      dcmd.setDbmodel(tmpdbmodel);
      req.addCommand(sc);
      req.addCommand(dcmd);
      this.setWaitCursor();
      ServerResponse resp = null;

      label41: {
         try {
            resp = SendHelper.sendRequest(req);
            this.setStatus(resp, "审批", 4, 8);
            break label41;
         } catch (Exception var15) {
            Exception e = var15;
            this.errorMessage("错误", "审批不成功原因:" + e.getMessage());
            e.printStackTrace();
         } finally {
            this.setDefaultCursor();
         }

         return;
      }

      this.setDefaultCursor();
      this.setDefaultCursor();
      this.setDefaultCursor();
   }

   void setStatus(ServerResponse resp, String command, int start, int end) throws Exception {
      String respcmd = resp.getCommand();
      if (respcmd.startsWith("+OK")) {
         this.infoMessage("提示", "确定成功！");
         this.getMasterModel().tableChanged();
         this.getDetailModel().tableChanged();
      } else {
         DBTableModel model = this.getMasterModel().getDBtableModel();
         DataCommand respdcmd = (DataCommand)resp.commandAt(0);
         DBTableModel tmpdbmodel = respdcmd.getDbmodel();
         int count = tmpdbmodel.getColumnCount();

         for(int r = 0; r < tmpdbmodel.getRowCount(); ++r) {
            String salesid = tmpdbmodel.getItemValue(r, "salesid");
            String message = tmpdbmodel.getItemValue(r, "message");

            for(int j = 0; j < model.getRowCount(); ++j) {
               String tmpsalesid = model.getItemValue(j, "salesid");
               if (tmpsalesid.equals(salesid)) {
                  int i;
                  String colname;
                  if (message.startsWith("+OK")) {
                     for(i = start; i <= end && i < count; ++i) {
                        colname = tmpdbmodel.getColumnDBName(i);
                        model.setItemValue(j, colname, tmpdbmodel.getItemValue(r, colname));
                        if (command.equals("回退确定")) {
                           model.setItemValue(j, "approvemanid", "");
                           model.setItemValue(j, "approvedate", "");
                           model.setItemValue(j, "approvememo", "");
                           model.setItemValue(j, "approveflag", "0");
                        }
                     }

                     String autoflag = model.getItemValue(j, "autoflag");
                     colname = model.getItemValue(j, "confirmflag");
                     if ("".equals(autoflag) && "1".equals(colname)) {
                        model.setdbStatus(j, 0);
                        model.getRecordThunk(j).setSaveresult(0, String.valueOf(String.valueOf(String.valueOf(command))) + "成功,由细单没有采集序列号自动出库记账失败");
                     } else {
                        model.setdbStatus(j, 0);
                        model.getRecordThunk(j).setSaveresult(0, String.valueOf(String.valueOf(String.valueOf(command))) + "成功");
                     }
                  } else if (message.startsWith("-ERROR")) {
                     model.getRecordThunk(j).setSaveresult(1, message);
                  } else if (message.startsWith("-INFO")) {
                     for(i = start; i <= end && i < count; ++i) {
                        colname = tmpdbmodel.getColumnDBName(i);
                        model.setItemValue(j, colname, tmpdbmodel.getItemValue(r, colname));
                     }

                     model.setdbStatus(j, 0);
                     model.getRecordThunk(j).setSaveresult(1, message);
                  }

                  if (command.equals("确定") && message.startsWith("+OK1")) {
                     model.getRecordThunk(j).setSaveresult(0, String.valueOf(String.valueOf(String.valueOf(command))) + "成功!有赠品出库单生成，请注意检查!");
                  }
                  break;
               }
            }
         }

         this.getMasterModel().doRequery();
         this.getMasterModel().tableChanged();
         this.getDetailModel().tableChanged();
      }

      if (respcmd.equals("Again")) {
         int option = JOptionPane.showConfirmDialog(this.frame, "销售价格应高于批发最低限价，低于国家零售价\n是否继续？");
         if (option == 0) {
            this.confirm(false);
         }
      }

   }

   static DBTableModel createCommitParamdbmodel() {
      Vector<DBColumnDisplayInfo> cols = new Vector();
      DBColumnDisplayInfo col = new DBColumnDisplayInfo("salesid", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("message", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("approveflag", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("isCommit", "varchar");
      cols.add(col);
      return new DBTableModel(cols);
   }

   static DBTableModel createCheckParamdbmodel() {
      Vector<DBColumnDisplayInfo> cols = new Vector();
      DBColumnDisplayInfo col = new DBColumnDisplayInfo("salesid", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("message", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("approvememo", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("isCommit", "varchar");
      cols.add(col);
      return new DBTableModel(cols);
   }

   static DBTableModel createApproveParamdbmodel() {
      Vector<DBColumnDisplayInfo> cols = new Vector();
      DBColumnDisplayInfo col = new DBColumnDisplayInfo("salesid", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("message", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("approve", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("appcheckinfo", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("approveflag", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("approvemanname", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("approvemanid", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("approvedate", "date");
      cols.add(col);
      col = new DBColumnDisplayInfo("approvememo", "varchar");
      cols.add(col);
      return new DBTableModel(cols);
   }

   static DBTableModel createConfirmParamdbmodel() {
      Vector<DBColumnDisplayInfo> cols = new Vector();
      DBColumnDisplayInfo col = new DBColumnDisplayInfo("salesid", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("message", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("autofix", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("autokeep", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("usestatus", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("confirmaname", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("confirmdate", "date");
      cols.add(col);
      col = new DBColumnDisplayInfo("confirmanid", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("approveflag", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("allowfix", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("autofixraise", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("storageid", "number");
      cols.add(col);
      return new DBTableModel(cols);
   }

   static DBTableModel createUnConfirmParamdbmodel() {
      Vector<DBColumnDisplayInfo> cols = new Vector();
      DBColumnDisplayInfo col = new DBColumnDisplayInfo("salesid", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("message", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("usestatus", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("confirmaname", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("confirmdate", "date");
      cols.add(col);
      col = new DBColumnDisplayInfo("confirmanid", "number");
      cols.add(col);
      return new DBTableModel(cols);
   }

   static DBTableModel createInvalidParamdbmodel() {
      Vector<DBColumnDisplayInfo> cols = new Vector();
      DBColumnDisplayInfo col = new DBColumnDisplayInfo("salesid", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("message", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("salesdtlid", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("preparestatus", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("usestatus", "number");
      cols.add(col);
      return new DBTableModel(cols);
   }

   static DBTableModel createRejectdbmodel() {
      Vector<DBColumnDisplayInfo> cols = new Vector();
      DBColumnDisplayInfo col = new DBColumnDisplayInfo("salesid", "number");
      cols.add(col);
      col = new DBColumnDisplayInfo("rejectMemo", "varchar");
      cols.add(col);
      col = new DBColumnDisplayInfo("approveflag", "number");
      cols.add(col);
      return new DBTableModel(cols);
   }

   protected boolean chkCompanyLicense(String companyid, String goodsid, String permitoverdays, String warndays, int row) throws Exception {
      ClientRequest request = new ClientRequest();
      ServerResponse response = null;
      StringCommand strcmd = new StringCommand("证照管理:证照期限检查");
      ParamCommand paramcmd = new ParamCommand();
      StringCommand strcmdResp = null;
      String message = null;
      String chkflag = null;
      boolean flag = true;
      paramcmd.addParam("companyid", companyid);
      paramcmd.addParam("goodsid", goodsid);
      paramcmd.addParam("permitoverdays", permitoverdays);
      paramcmd.addParam("warndays", warndays);
      request.addCommand(strcmd);
      request.addCommand(paramcmd);
      response = SendHelper.sendRequest(request);
      strcmdResp = (StringCommand)response.commandAt(0);
      if (strcmdResp.getString().startsWith("+OK")) {
         ParamCommand paramcmdresp = (ParamCommand)response.commandAt(1);
         message = paramcmdresp.getValue("message");
         chkflag = paramcmdresp.getValue("flag");
         if (message != null && message.length() > 0) {
            this.infoMessage("提示", message);
         }
      }

      if (chkflag != null && chkflag.equals("0")) {
         flag = false;
      }

      if (flag) {
         return true;
      } else {
         if (goodsid != null && goodsid.length() != 0) {
            this.detailmodel.setItemValue(row, "opcode", "");
            this.detailmodel.setItemValue(row, "goodsid", "");
            this.detailmodel.setItemValue(row, "goodsname", "");
            this.detailmodel.setItemValue(row, "goodsno", "");
            this.detailmodel.setItemValue(row, "goodsunit", "");
            this.detailmodel.setItemValue(row, "goodsdtlid", "");
            this.detailmodel.setItemValue(row, "currencyname", "");
            this.detailmodel.setItemValue(row, "factoryname", "");
            this.detailmodel.setItemValue(row, "prodarea", "");
            this.detailmodel.setItemValue(row, "packsize", "");
            this.detailmodel.setItemValue(row, "packname", "");
            this.detailmodel.setItemValue(row, "goodstype", "");
         } else {
            this.mastermodel.setItemValue(row, "customopcode", "");
            this.mastermodel.setItemValue(row, "customid", "");
            this.mastermodel.setItemValue(row, "customno", "");
            this.mastermodel.setItemValue(row, "customname", "");
         }

         return false;
      }
   }

   public void doNew() {
      this.detailmodel.commitEdit();
      int rowcount = this.detailmodel.getModifiedDbmodel().getRowCount();
      int k = 0;

      while(k < rowcount) {
         String unitprice = this.detailmodel.getModifiedDbmodel().getItemValue(k, "unitprice");
         if (unitprice != null && !"".equals(unitprice)) {
            String goodsuseunit = this.detailmodel.getModifiedDbmodel().getItemValue(k, "goodsuseunit");
            if (goodsuseunit != null && !"".equals(goodsuseunit)) {
               String goodsuseqty = this.detailmodel.getModifiedDbmodel().getItemValue(k, "goodsuseqty");
               if (goodsuseqty != null && !"".equals(goodsuseqty)) {
                  String discount = this.detailmodel.getModifiedDbmodel().getItemValue(k, "discount");
                  if (discount != null && !"".equals(discount)) {
                     ++k;
                     continue;
                  }

                  this.infoMessage("提示", "数据项‘折扣’不能为空!");
                  return;
               }

               this.infoMessage("提示", "数据项‘使用单位数量’不能为空!");
               return;
            }

            this.infoMessage("提示", "数据项‘使用单位’不能为空!");
            return;
         }

         this.infoMessage("提示", "数据项‘单价’不能为空！");
         return;
      }

      super.doNew();
   }

   private void backSubmit() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行确定!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行确定!");
      } else {
         for(int i = 0; i < this.getMasterModel().getRowCount(); ++i) {
            if (this.getMasterModel().getdbStatus(i) != 0) {
               this.warnMessage("警告", "没有保存不能确定,请先保存!");
               return;
            }
         }

         String approveflag = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "approveflag");
         String usestatus = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
         if (!"2".equals(approveflag)) {
            this.warnMessage("警告", "不是待审批状态，不能回退提交！");
         } else if (!"2".equals(usestatus)) {
            this.warnMessage("警告", "不是临时状态，不能回退提交！");
         } else {
            String salesid = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "salesid");
            ClientRequest req = new ClientRequest();
            req.addCommand(new StringCommand("Bms_sales_mde.销售发货单管理.doBackSubmit.回退提交"));
            req.addCommand(new StringCommand(salesid));
            ServerResponse resp = null;

            try {
               resp = SendHelper.sendRequest(req);
            } catch (Exception var7) {
               Exception e = var7;
               e.printStackTrace();
            }

            String cmd = ((StringCommand)resp.commandAt(0)).getString();
            if (cmd.equals("+OK")) {
               this.getMasterModel().setItemValue(this.getMasterModel().getRow(), "approveflag", "0");
               this.getMasterModel().setdbStatus(this.getMasterModel().getRow(), 0);
               this.getMasterModel().getDBtableModel().getRecordThunk(this.getMasterModel().getRow()).setSaveresult(0, "回退提交完成！");
               this.getMasterModel().tableChanged();
            } else {
               this.errorMessage("错误", cmd);
            }

         }
      }
   }

   private void inputeSequence(String companyid, String rgtype, int drow, String goodsqty) throws Exception {
      String goodsid = this.detailmodel.getItemValue(drow, "goodsid");
      String entryid = ClientUserManager.getCurrentUser().getEntryid();
      String userid = ClientUserManager.getCurrentUser().getUserid();
      boolean rv = NptrDBHelper.checkGoodsSeqFlag(goodsid, entryid);
      if (!rv) {
         this.infoMessage("提示", "该货品不是采集序列号品种");
      } else {
         String storageid = this.detailmodel.getItemValue(drow, "storageid");
         String lotid = this.detailmodel.getItemValue(drow, "lotid");
         String salesdtlid = this.detailmodel.getItemValue(drow, "salesdtlid");
         int comefrom = 0;
         if (rgtype != null && "1".equals(rgtype)) {
            comefrom = 3;
         }

         if (rgtype != null && "2".equals(rgtype)) {
            comefrom = 4;
         }

         DBTableModel seqCode = this.getSequenceCode(storageid, goodsid, lotid, String.valueOf(comefrom), entryid);
         DBTableModel dbmodeltemp = this.getExistsSequence(goodsid, String.valueOf(comefrom), salesdtlid);
         DBTableModel dbmodellst = seqCode.copyStruct();
         boolean insert_dbmodeltemp = false;

         for(int i = 0; i < seqCode.getRowCount(); ++i) {
            insert_dbmodeltemp = true;
            String sequencecode = seqCode.getItemValue(i, "sequencecode").trim();

            for(int j = 0; j < dbmodeltemp.getRowCount(); ++j) {
               String sequencecode2 = dbmodeltemp.getItemValue(j, "sequencecode").trim();
               if (sequencecode.equals(sequencecode2)) {
                  insert_dbmodeltemp = false;
                  break;
               }
            }

            if (insert_dbmodeltemp) {
               RecordTrunk rt = seqCode.getRecordThunk(i);
               dbmodellst.appendRecord(rt);
            }
         }

         ListSetDialog setRangeDialog = new ListSetDialog(this.getParentFrame(), dbmodeltemp, dbmodellst);
         goodsqty = DecimalHelper.divide(goodsqty, "1", 0);
         setRangeDialog.setSeqnum(Integer.parseInt(goodsqty));
         setRangeDialog.setCremanid(userid);
         setRangeDialog.setVisible(true);
         if (setRangeDialog.isOk()) {
            DBTableModel db = setRangeDialog.getRemodel();
            ParamCommand param = new ParamCommand();
            param.addParam("lotid", lotid);
            param.addParam("inoutType", "1");
            param.addParam("goodsid", goodsid);
            param.addParam("sourceid", salesdtlid);
            param.addParam("sourcetype", String.valueOf(comefrom));
            param.addParam("storageid", storageid);
            param.addParam("memo", "销售发货单BMS_SA_DOC");
            param.addParam("comefrom", String.valueOf(comefrom));
            DataCommand dc = new DataCommand();
            dc.setDbmodel(db);
            ClientRequest request = new ClientRequest("Bms_sales_mde.销售发货单序列号");
            request.addCommand(param);
            request.addCommand(dc);
            ServerResponse sr = null;
            sr = SendHelper.sendRequest(request);
            String retMsg = ((StringCommand)sr.commandAt(0)).getString();
            if (retMsg != null && retMsg.startsWith("+OK")) {
               String NOTOK = ((StringCommand)sr.commandAt(1)).getString();
               if ("+NOTOK".equals(NOTOK)) {
                  if (db.getRowCount() > 0) {
                     this.infoMessage("提示", "采集的序列号有已经被别人占用的，请补充采集!");
                     this.detailmodel.getDBtableModel().getRecordThunk(drow).setSaveresult(0, "序列号采集部分成功");
                  } else {
                     this.detailmodel.getDBtableModel().getRecordThunk(drow).setSaveresult(0, "");
                  }
               } else if (db.getRowCount() > 0) {
                  this.infoMessage("提示", "序列号采集成功!");
                  this.detailmodel.setItemValue(drow, "gather", "1");
                  this.detailmodel.setdbStatus(drow, 0);
                  this.detailmodel.getDBtableModel().getRecordThunk(drow).setSaveresult(0, "序列号采集成功");
               } else {
                  this.detailmodel.getDBtableModel().getRecordThunk(drow).setSaveresult(0, "");
               }
            } else {
               this.detailmodel.getDBtableModel().getRecordThunk(drow).setSaveresult(1, retMsg);
            }

            this.mastermodel.tableChanged();
            this.detailmodel.tableChanged();
         }
      }
   }

   private DBTableModel getSequenceCode(String storageid, String goodsid, String lotid, String comefrom, String entryid) throws Exception {
      String sql = String.format("select a.sequencecode from zx_storage_seq_mag a,bms_st_def b where nvl(a.gatheflag,0)=0 and a.storageid=b.storageid and a.storageid=%s and a.goodsid=%s and a.lotid=%s and b.entryid=%s order by a.sequencecode", storageid, goodsid, lotid, entryid, comefrom);
      RemotesqlHelper select = new RemotesqlHelper();
      DBTableModel return_value = select.doSelect(sql, 0, 2147483646);
      return return_value;
   }

   private DBTableModel getExistsSequence(String goodsid, String sourcetype, String sourceid) throws Exception {
      String sql = String.format("select  sequencecode ,cremanid,credate from zx_goods_seq_tmpmag where entryid=%s and goodsid=%s and sourcetype=%s and sourceid=%s order by sequencecode", ClientUserManager.getCurrentUser().getEntryid(), goodsid, sourcetype, sourceid);
      RemotesqlHelper select = new RemotesqlHelper();
      DBTableModel return_value = select.doSelect(sql, 0, 2147483646);
      return return_value;
   }
}
